> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a dataset

> Create a new Dataset. Requires access to the project the dataset will originate from



## OpenAPI

````yaml /api-specs/6.3/public-api.json post /api/datasetrw/v1/datasets
openapi: 3.0.3
info:
  title: Domino Public API
  description: Reference for Domino's public REST API endpoints.
  version: 6.3.1
  x-catalog-key: nucleus
servers:
  - url: https://mycluster.domino.tech
    description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
security: []
tags:
  - name: Projects
  - name: Project templates
  - name: Workspaces
  - name: Jobs
  - name: HPC Jobs
  - name: Environments
  - name: Hardware Tiers
  - name: Datasets
  - name: Data Sources
  - name: AI Gateway
  - name: GenAI
  - name: AI Systems
  - name: Apps
  - name: App versions
  - name: App instances
  - name: Model APIs
  - name: Registered models
  - name: Model deployment
  - name: Extensions
  - name: Cost and billing
  - name: Users and organizations
  - name: Service accounts
  - name: Personal Access Tokens
  - name: Personal Access Tokens (admin)
  - name: Audit Trail
  - name: Custom metrics
  - name: PPM
  - name: Model Monitoring models
  - name: Model Monitoring drift and quality
  - name: Model Monitoring settings
  - name: Model Monitoring authentication
  - name: Governance bundles
  - name: Governance policies
  - name: Governance evidence and results
  - name: Governance operations
  - name: NetApp Volumes
  - name: NetApp Volumes snapshots
  - name: NetApp Volumes filesystems
  - name: NetApp Volumes transfers
  - name: Tags
  - name: Properties
externalDocs:
  description: OpenAPI
  url: https://swagger.io/resources/open-api/
paths:
  /api/datasetrw/v1/datasets:
    post:
      tags:
        - Datasets
      summary: Create a dataset
      description: >-
        Create a new Dataset. Requires access to the project the dataset will
        originate from
      operationId: createDataset
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/NewDatasetRwV1'
        description: Dataset to create
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DatasetRwEnvelopeV1'
          description: Success
        '400':
          $ref: '#/components/responses/400'
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
        '500':
          $ref: '#/components/responses/500'
      security:
        - DominoApiKey: []
        - BearerAuthentication: []
components:
  schemas:
    NewDatasetRwV1:
      properties:
        description:
          description: Description of the dataset
          type: string
        grants:
          description: >-
            Permission grants to be assigned for this newly created dataset.
            Note that permissions can be edited after creation. If snapshotId is
            passed in, this parameter won't have any effect and caller will be
            assigned dataset Ownership.
          items:
            $ref: '#/components/schemas/DatasetRwGrantV1'
          type: array
        name:
          description: Name of this dataset. The name must be unique in the same project
          type: string
        projectId:
          description: >-
            ID of the project this dataset belongs to. Either projectId or
            snapshotId must be provided
          type: string
        snapshotId:
          description: >-
            ID of an existing snapshot to create a new dataset from. Either
            snapshotId or projectId must be provided.
          type: string
      required:
        - name
      type: object
    DatasetRwEnvelopeV1:
      properties:
        dataset:
          $ref: '#/components/schemas/DatasetRwDetailsV1'
        metadata:
          $ref: '#/components/schemas/MetadataV1'
      required:
        - dataset
        - metadata
      type: object
    DatasetRwGrantV1:
      properties:
        targetId:
          description: ID of the user within the grant
          type: string
        targetRole:
          $ref: '#/components/schemas/DatasetRwRoleV1'
      required:
        - targetId
        - targetRole
      type: object
    DatasetRwDetailsV1:
      properties:
        createdAt:
          description: When the dataset was created
          example: '2022-03-12T02:13:44.467Z'
          format: date-time
          type: string
        description:
          description: A description of the dataset
          type: string
        id:
          description: ID of the dataset
          example: 62313ce67a0af0281c01a6a5
          type: string
        name:
          description: Name of the dataset
          example: My Dataset
          type: string
        projectId:
          description: ID of the project this dataset belongs to
          example: 62313ce67a0af0281c01a6a5
          type: string
        snapshotIds:
          description: List of snapshot IDs belonging to this dataset
          items:
            type: string
          type: array
        tags:
          $ref: '#/components/schemas/DatasetRwTagsV1'
      required:
        - id
        - name
        - createdAt
        - snapshotIds
        - tags
      type: object
    MetadataV1:
      properties:
        notices:
          description: Notices relating to the request
          items:
            type: string
          type: array
        requestId:
          type: string
      required:
        - requestId
        - notices
      type: object
    ErrorV1:
      properties:
        code:
          description: Machine-readable error code.
          example: NOT_FOUND
          type: string
        message:
          description: Human-readable description of the error.
          example: The requested HPC Job could not be found.
          type: string
      required:
        - message
      type: object
    DatasetRwRoleV1:
      description: >-
        Role that the user will assume in the dataset. Note that organizations
        cannot be dataset Owners
      enum:
        - DatasetRwOwner
        - DatasetRwEditor
        - DatasetRwReader
      type: string
    DatasetRwTagsV1:
      additionalProperties:
        type: string
      description: A map of tagName -> snapshotId
      example:
        bar: 62313ce67a0af0281c01a6a5
        foo: 62313ce67a0af0281c01a6a5
      type: object
  responses:
    '400':
      content:
        application/json:
          schema:
            properties:
              error:
                type: string
            type: object
      description: Bad Request
    '401':
      content:
        application/json:
          example:
            code: UNAUTHORIZED
            message: Authentication is required to access this resource.
          schema:
            $ref: '#/components/schemas/ErrorV1'
      description: Unauthorized - authentication is required or has failed.
    '403':
      content:
        application/json:
          example:
            code: FORBIDDEN
            message: You do not have permission to perform this action.
          schema:
            $ref: '#/components/schemas/ErrorV1'
      description: Forbidden - the caller lacks permission to perform this action.
    '404':
      content:
        application/json:
          schema:
            properties:
              error:
                type: string
            type: object
      description: Not Found
    '500':
      content:
        application/json:
          schema:
            properties:
              error:
                type: string
            type: object
      description: Internal Server Error
  securitySchemes:
    DominoApiKey:
      type: apiKey
      in: header
      name: X-Domino-Api-Key
    BearerAuthentication:
      type: apiKey
      name: Authorization
      in: header

````

## Related topics

- [Create and manage Datasets](/6.3/platform-capabilities/core-concepts/data/datasets/create-and-manage-datasets.md)
- [Datasets administration](/6.3/admin/data-administration/datasets.md)
- [Share Datasets securely](/6.3/platform-capabilities/core-concepts/data/sharing-and-security/share-datasets.md)
- [Version data with Snapshots](/6.3/platform-capabilities/core-concepts/data/datasets/version-data-with-snapshots.md)
